scala.collection.parallel.mutable

# ParHashTable

###
Related Doc: package mutable

#### trait ParHashTable[K, Entry >: Null <: HashEntry[K, Entry]] extends HashTable[K, Entry]

Provides functionality for hash tables with linked list buckets, enriching the data structure by fulfilling certain requirements for their parallel construction and iteration.

Source
  ParHashTable.scala

Linear Supertypes
HashTable[K, Entry], HashUtils[K], AnyRef, Any
Known Subclasses
ParHashMap
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ParHashTable
2. HashTable
3. HashUtils
4. AnyRef
5. Any

Implicitly

1. by CollectionsHaveToParArray
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### abstract class EntryIterator[T, +IterRepr <: IterableSplitter[T]] extends IterableSplitter[T] with SizeMapUtils

   A parallel iterator returning all the entries.

### Abstract Value Members

1. #### abstract def createNewEntry[B](key: K, value: B): Entry

   Creates new entry to be immediately inserted into the hashtable.

   Creates new entry to be immediately inserted into the hashtable. This method is guaranteed to be called only once and in case that the entry will be added. In other words, an implementation may be side-effecting.

   Attributes
     protected
   Definition Classes
     HashTable

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ParHashTable[K, Entry] to any2stringadd[ParHashTable[K, Entry]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ParHashTable[K, Entry], B)

   Implicit information
     This member is added by an implicit conversion from ParHashTable[K, Entry] to ArrowAssoc[ParHashTable[K, Entry]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### var _loadFactor: Int

   Attributes
     protected
   Definition Classes
     HashTable

7. #### def addEntry(e: Entry): Unit

   Add entry to table pre: no entry with same key exists

   Add entry to table pre: no entry with same key exists

   Attributes
     protected
   Definition Classes
     HashTable
   Annotations
     @deprecatedOverriding( ... , "2.11.0" )

8. #### def alwaysInitSizeMap: Boolean

   Definition Classes
     ParHashTable → HashTable

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### def calcSizeMapSize(tableLength: Int): Int

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

11. #### def clearTable(): Unit

    Remove all entries from table

    Remove all entries from table

    Attributes
      protected
    Definition Classes
      HashTable

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def elemEquals(key1: K, key2: K): Boolean

    Attributes
      protected
    Definition Classes
      HashTable

14. #### def elemHashCode(key: K): Int

    Attributes
      protected
    Definition Classes
      HashUtils

15. #### def ensuring(cond: (ParHashTable[K, Entry]) ⇒ Boolean, msg: ⇒ Any): ParHashTable[K, Entry]

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to Ensuring[ParHashTable[K, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (ParHashTable[K, Entry]) ⇒ Boolean): ParHashTable[K, Entry]

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to Ensuring[ParHashTable[K, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): ParHashTable[K, Entry]

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to Ensuring[ParHashTable[K, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): ParHashTable[K, Entry]

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to Ensuring[ParHashTable[K, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def entriesIterator: Iterator[Entry]

    An iterator returning all entries.

    An iterator returning all entries.

    Attributes
      protected
    Definition Classes
      HashTable

20. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

22. #### def findEntry(key: K): Entry

    Find entry with given key in table, null if not found.

    Find entry with given key in table, null if not found.

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

23. #### def findOrAddEntry[B](key: K, value: B): Entry

    Find entry with given key in table, or add new one if not found.

    Find entry with given key in table, or add new one if not found. May be somewhat faster then `findEntry`/`addEntry` pair as it computes entry's hash index only once. Returns entry found in table or null. New entries are created by calling `createNewEntry` method.

    Attributes
      protected
    Definition Classes
      HashTable

24. #### def foreachEntry[U](f: (Entry) ⇒ U): Unit

    Avoid iterator for a 2x faster traversal.

    Avoid iterator for a 2x faster traversal.

    Attributes
      protected
    Definition Classes
      HashTable

25. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to StringFormat[ParHashTable[K, Entry]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

27. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

28. #### final def improve(hcode: Int, seed: Int): Int

    Defer to a high-quality hash in scala.util.hashing.

    Defer to a high-quality hash in scala.util.hashing. The goal is to distribute across bins as well as possible even if a hash code has low entropy at some bits.

    OLD VERSION - quick, but bad for sequence 0-10000 - little entropy in higher bits - since 2003

        var h: Int = hcode + ~(hcode << 9)
        h = h ^ (h >>> 14)
        h = h + (h << 4)
        h ^ (h >>> 10)

    the rest of the computation is due to SI-5293

    Attributes
      protected
    Definition Classes
      HashUtils

29. #### final def index(hcode: Int): Int

    Note: we take the most significant bits of the hashcode, not the lower ones this is of crucial importance when populating the table in parallel

    Note: we take the most significant bits of the hashcode, not the lower ones this is of crucial importance when populating the table in parallel

    Attributes
      protected
    Definition Classes
      HashTable

30. #### def initWithContents(c: Contents[K, Entry]): Unit

    Attributes
      protected
    Definition Classes
      HashTable

31. #### def initialSize: Int

    The initial size of the hash table.

    The initial size of the hash table.

    Attributes
      protected
    Definition Classes
      HashTable

32. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

33. #### def isSizeMapDefined: Boolean

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### def nnSizeMapAdd(h: Int): Unit

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

36. #### def nnSizeMapRemove(h: Int): Unit

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

37. #### def nnSizeMapReset(tableLength: Int): Unit

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

38. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

39. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

40. #### def removeEntry(key: K): Entry

    Remove entry from table if present.

    Remove entry from table if present.

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

41. #### var seedvalue: Int

    Attributes
      protected
    Definition Classes
      HashTable

42. #### final def sizeMapBucketBitSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

43. #### final def sizeMapBucketSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

44. #### def sizeMapDisable(): Unit

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

45. #### def sizeMapInit(tableLength: Int): Unit

    Attributes
      protected
    Definition Classes
      HashTable

46. #### def sizeMapInitAndRebuild(): Unit

    Attributes
      protected
    Definition Classes
      HashTable
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

47. #### var sizemap: Array[Int]

    The array keeping track of the number of elements in 32 element blocks.

    The array keeping track of the number of elements in 32 element blocks.

    Attributes
      protected
    Definition Classes
      HashTable

48. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

49. #### var table: Array[HashEntry[K, Entry]]

    The actual hash table.

    The actual hash table.

    Attributes
      protected
    Definition Classes
      HashTable

50. #### var tableSize: Int

    The number of mappings contained in this hash table.

    The number of mappings contained in this hash table.

    Attributes
      protected
    Definition Classes
      HashTable

51. #### def tableSizeSeed: Int

    Attributes
      protected
    Definition Classes
      HashTable

52. #### var threshold: Int

    The next size value at which to resize (capacity * load factor).

    The next size value at which to resize (capacity * load factor).

    Attributes
      protected
    Definition Classes
      HashTable

53. #### def toParArray: ParArray[T]

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to CollectionsHaveToParArray[ParHashTable[K, Entry], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (ParHashTable[K, Entry]) ⇒ GenTraversableOnce[T] is in scope.
    Definition Classes
      CollectionsHaveToParArray

54. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

55. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

56. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### def →[B](y: B): (ParHashTable[K, Entry], B)

    Implicit information
      This member is added by an implicit conversion from ParHashTable[K, Entry] to ArrowAssoc[ParHashTable[K, Entry]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from HashTable[K, Entry]

### Inherited from HashUtils[K]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from ParHashTable[K, Entry] to CollectionsHaveToParArray[ParHashTable[K, Entry], T]

### Inherited by implicit conversion any2stringadd from ParHashTable[K, Entry] to any2stringadd[ParHashTable[K, Entry]]

### Inherited by implicit conversion StringFormat from ParHashTable[K, Entry] to StringFormat[ParHashTable[K, Entry]]

### Inherited by implicit conversion Ensuring from ParHashTable[K, Entry] to Ensuring[ParHashTable[K, Entry]]

### Inherited by implicit conversion ArrowAssoc from ParHashTable[K, Entry] to ArrowAssoc[ParHashTable[K, Entry]]

### Ungrouped